forprefmap <- function(dataset,col.p,col.j,col.lik,id.recogn,rm.j=TRUE){
    dataset[,col.p] <- as.factor(dataset[,col.p])
    product <- levels(dataset[,col.p])
    nbprod <- length(product)
    dataset[,col.j] <- as.factor(dataset[,col.j])
    juge <- levels(dataset[,col.j])
    nbjuge <- length(juge)
    desc <- dataset[,c(col.j,col.p)]
    id.pos <- grep(id.recogn,colnames(dataset))
    intensity <- dataset[,id.pos-1]
    int.data <- cbind(desc,intensity)
    liking <- as.matrix(dataset[,col.lik])
    colnames(liking) <- "liking"
    lik.data <- cbind(desc,liking)
    int.avg <- averagetable(int.data,formul=paste("~",colnames(dataset)[col.p],"+",colnames(dataset)[col.j],sep=""),firstvar=3,method="coeff")
    lik.j <- matrix(0,nbprod,0)
    rownames(lik.j) <- product
    for (j in 1:nbjuge){
        lik.j.temp <- lik.data[lik.data[,1]==juge[j],]
        lik.j.temp.rn <- lik.j.temp[,2]
        lik.j.temp <- as.matrix(lik.j.temp[,3])
        rownames(lik.j.temp) <- lik.j.temp.rn
        lik.j <- merge(lik.j,lik.j.temp,all=T,by=0,sort=F)
        lik.j.rn <- lik.j[,1]
        lik.j <- as.matrix(lik.j[,-1])
        rownames(lik.j) <- lik.j.rn
        colnames(lik.j)[ncol(lik.j)] <- juge[j]
    }
    if (rm.j){
        rm.c <- NULL
        for (j in 1:ncol(lik.j))
            if (var(na.omit(lik.j[,j]))==0)
                rm.c <- c(rm.c,j)
        if (!is.null(rm.c)){
            lik.j <- lik.j[,-rm.c]
            juge.rm <- juge[rm.c]
        } else {
            juge.rm <- NULL
        }
    }
    res <- list()
    res$senso <- int.avg
    res$hedo <- as.data.frame(lik.j)
    if (rm.j)
        juge.rm
    return(res)
}