ideal.sd <- function(dataset,col.p,col.j,id.recogn,split.byatt=FALSE){
    dataset[,col.p] <- as.factor(dataset[,col.p])
    product <- levels(dataset[,col.p])
    nbprod <- length(product)
    dataset[,col.j] <- as.factor(dataset[,col.j])
    juge <- levels(dataset[,col.j])
    nbjuge <- length(juge)
    descp <- dataset[,c(col.j,col.p)]
    id.seq <- grep(id.recogn,colnames(dataset))
    if (length(id.seq)<2)
        stop("Not convenient 'id.recogn' definition")
    intensity <- dataset[,id.seq-1]
    attribut.int <- colnames(intensity)
    ideal <- dataset[,id.seq]
    attribut.id <- colnames(ideal)
    nbatt <- length(attribut.int)
    int.data <- cbind(descp,intensity)
    id.data <- cbind(descp,ideal)
    int.sd <- id.sd <- sd.ratio <- matrix(NA,nbjuge,nbatt)
    rownames(int.sd) <- rownames(id.sd) <- rownames(sd.ratio) <- juge
    colnames(int.sd) <- colnames(sd.ratio) <- attribut.int
    colnames(id.sd) <- attribut.id
    for (j in 1:nbjuge){
        int.data.j <- int.data[int.data[,1]==juge[j],-c(1,2)]
        id.data.j <- id.data[id.data[,1]==juge[j],-c(1,2)]
        for (att in 1:nbatt){
            int.sd[j,att] <- round(sd(na.omit(int.data.j[,att])),2)
            id.sd[j,att] <- round(sd(na.omit(id.data.j[,att])),2)
            sd.ratio[j,att] <- round(sd(na.omit(id.data.j[,att]))/sd(na.omit(int.data.j[,att])),2)
        }
    }
    sd.ratio2 <- sd.ratio
    for (i in 1:nrow(sd.ratio))
        for (j in 1:ncol(sd.ratio))
            if (!is.na(sd.ratio[i,j]))
                if (sd.ratio[i,j]>=5)
                    sd.ratio2[i,j]=5
    layout(matrix(1:2,1,2))
    plot(density(sd.ratio2),xlim=c(0,3),xlab="sd(ideal) / sd(perceived)",main="Standard deviation ratio")
    abline(v=1,col="red3")
    int.sd.j <- apply(int.sd,1,mean,na.action=na.omit)
    id.sd.j <- apply(id.sd,1,mean,na.action=na.omit)
    int.sd.att <- apply(int.sd,2,mean,na.action=na.omit)
    id.sd.att <- apply(id.sd,2,mean,na.action=na.omit)
    vmax <- 10*round(ceiling(max(max(na.omit(int.sd.j)),max(na.omit(id.sd.j)),max(na.omit(id.sd.att)),max(na.omit(id.sd.att)))/10),1)
    plot(int.sd.j,id.sd.j,type="n",xlim=c(0,vmax),ylim=c(0,vmax),xlab="sd(perceived)",ylab="sd(ideal)",main="Standard deviation")
    for (j in 1:nbjuge)
        text(int.sd.j[j],id.sd.j[j],label=juge[j],col="green3",cex=0.6)
    for (att in 1:nbatt)
        text(int.sd.att[att],id.sd.att[att],label=attribut.int[att],col="blue3",cex=0.6)
    abline(a=0,b=1,lty=3,col="red3")
    legend("topleft",legend=c("juge","attribute"),text.col=c("green3","blue3"),cex=0.8,bty="n")
    if (split.byatt){
        vmax <- 10*round(ceiling(max(max(na.omit(int.sd)),max(na.omit(id.sd)))/10),1)
        for (att in 1:nbatt){
            dev.new()
            layout(matrix(1:2,1,2))
            plot(density(sd.ratio2[,att]),xlim=c(0,3),xlab="sd(ideal) / sd(perceived)",main=attribut.int[att])
            abline(v=1,col="red3")
            plot(int.sd[,att],id.sd[,att],type="n",xlim=c(0,vmax),ylim=c(0,vmax),xlab="sd(perceived)",ylab="sd(ideal)",main=attribut.int[att])
            for (j in 1:nbjuge)
                text(int.sd[j,att],id.sd[j,att],label=juge[j],cex=0.6)
            abline(a=0,b=1,lty=3,col="red3")
        }
    }
    res <- list()
    res$sd.int <- int.sd
    res$sd.id <- id.sd
    res$sd.ratio <- sd.ratio
    return(res)
}