influence.ideal <- function(dataset,col.p,col.j,id.recogn,analysis="PCA"){
    dataset[,col.p] <- as.factor(dataset[,col.p])
    product <- levels(dataset[,col.p])
    nbprod <- length(product)
    prod.name <- colnames(dataset)[col.p]
    dataset[,col.j] <- as.factor(dataset[,col.j])
    juge <- levels(dataset[,col.j])
    nbjuge <- length(juge)
    juge.name <- colnames(dataset)[col.j]
    descp <- dataset[,c(col.j,col.p)]
    id.seq <- grep(id.recogn,colnames(dataset))
    if (length(id.seq)<2)
        stop("Not convenient 'id.recogn' definition")
    intensity <- dataset[,id.seq-1]
    attribut.int <- colnames(intensity)
    ideal <- dataset[,id.seq]
    attribut.id <- colnames(ideal)
    nbatt <- length(attribut.int)
    int.data <- cbind(descp,intensity)
    int.avg <- averagetable(int.data,formul=paste("~",prod.name,"+",juge.name,sep=""),firstvar=3)
    id.data <- cbind(descp,ideal)
    options(contrasts=c("contr.sum","contr.sum"))
    res.aov.temp <- list()
    data.analyse <- int.avg
    count=0
    for (att in 1:nbatt){
        res.aov.temp[1] <- as.matrix(summary(res.aov <- aov(as.formula(paste(attribut.id[att],"~",prod.name,"+",juge.name,sep="")),data=id.data)))
        coeff.prod <- as.matrix(summary.lm(res.aov)$coefficients[2:nbprod,1])
        coeff.prod <- rbind(coeff.prod,as.matrix(-sum(coeff.prod)))
        rownames(coeff.prod) <- product
        if (res.aov.temp[[1]][1,5]<=0.001){
            count=count+1
            colnames(coeff.prod) <- paste(attribut.id[att],"***",sep="")
        } else if (res.aov.temp[[1]][1,5]<=0.01){
            count=count+1
            colnames(coeff.prod) <- paste(attribut.id[att],"**",sep="")
        } else if (res.aov.temp[[1]][1,5]<=0.05){
            count=count+1
            colnames(coeff.prod) <- paste(attribut.id[att],"*",sep="")
        } else if (res.aov.temp[[1]][1,5]<=0.1){
            colnames(coeff.prod) <- paste(attribut.id[att],".",sep="")
        } else {
            colnames(coeff.prod) <- attribut.id[att]
        }
        data.analyse <- merge(data.analyse,coeff.prod,all=T,by=0,sort=F)
        rownames(data.analyse) <- data.analyse[,1]
        data.analyse <- data.analyse[,-1]
    }
    if (analysis=="PCA"){
        res.multi <- PCA(data.analyse,quanti.sup=(nbatt+1):ncol(data.analyse),graph=F)
        plot.PCA(res.multi,choix="ind",cex=0.7)
        plot.PCA(res.multi,choix="var",cex=0.7)
        title(sub="attribute significance: ***<0.001 ; **<0.01 ; *<0.05 ; .<0.10",cex.sub=0.8)
    } else if (analysis=="MFA"){
        res.multi <- MFA(data.analyse,group=rep(nbatt,2),type=rep("s",2),name.group=c("perceived","ideal"))
    } else {
        stop("Not convenient 'analyse' definition")
    }
    res.cor <- matrix(0,nbatt,1)
    rownames(res.cor) <- colnames(data.analyse)[(nbatt+1):ncol(data.analyse)]
    colnames(res.cor) <- "correlation"
    for (att in 1:nbatt)
        res.cor[att,1] <- round(cor(data.analyse[,att],data.analyse[,nbatt+att]),2)
    res <- list()
    res$data <- data.analyse
    res$analyse <- res.multi
    res$correlation <- res.cor
    res$num.att <- paste(count,"/",nbatt,sep="")
    return(res)
}