senso.consist <- function(dataset,col.p,col.j,col.lik,id.recogn,consist="both",scale.unit=TRUE,ncp=5,axes=c(1,2),correct=TRUE,replace.na=FALSE,graph=TRUE){
    if (!consist %in% c("consumer","panel","both"))
        stop("Inconvenient 'consist' definition.")
    dataset[,col.p] <- as.factor(dataset[,col.p])
    product <- levels(dataset[,col.p])
    nbprod <- length(product)
    prod.name <- colnames(dataset)[col.p]
    dataset[,col.j] <- as.factor(dataset[,col.j])
    juge <- levels(dataset[,col.j])
    nbjuge <- length(juge)
    juge.name <- colnames(dataset)[col.j]
    descp <- dataset[,c(col.j,col.p)]
    id.seq <- grep(id.recogn,colnames(dataset))
    if (length(id.seq)<2)
        stop("Not convenient 'id.recogn' definition")
    intensity <- dataset[,id.seq-1]
    attribut.int <- colnames(intensity)
    ideal <- dataset[,id.seq]
    attribut.id <- colnames(ideal)
    nbatt <- length(attribut.int)
    if (!is.numeric(col.lik)){
        pos.lik <- NULL
        for (a in 1:ncol(dataset))
            if (colnames(dataset)[a]==col.lik)
                pos.lik=a
        col.lik=pos.lik
    }
    if (is.null(col.lik) || col.lik %in% c(id.seq,(id.seq-1)))
        stop("Inconvenient 'Liking variable' definition")
    lik.name <- colnames(dataset)[col.lik]
    liking <- as.matrix(dataset[,col.lik])
    colnames(liking) <- lik.name
    lik.data <- cbind(descp,liking)
    int.data <- cbind(descp,intensity)
    int.avg.save <- averagetable(int.data,formul=paste("~",prod.name,"+",juge.name,sep=""),firstvar=3)
    id.data <- cbind(descp,ideal)
    id.avg.save <- averagetable(id.data,formul=paste("~",juge.name,"+",prod.name,sep=""),firstvar=3)
    if (consist %in% c("panel","both") || correct==T)
        int.avg.j <- averagetable(int.data,formul=paste("~",juge.name,"+",prod.name,sep=""),firstvar=3)
    res <- vector("list")
    if (consist %in% c("panel","both")){
        int.avg <- int.avg.save
        id.avg <- id.avg.save
        colnames(int.avg.j) <- colnames(int.avg) <- attribut.id
        id.avg <- id.avg-int.avg.j
        if (any(rownames(int.avg) %in% rownames(id.avg)))
            rownames(int.avg) <- paste("P_",rownames(int.avg),sep="")
        lik.info <- as.matrix(product)
        colnames(lik.info) <- prod.name
        for (j in 1:nbjuge){
            lik.j <- lik.data[lik.data[,1]==juge[j],-1]
            lik.info <- merge(lik.info,lik.j,by=prod.name,all=T,sort=F)
            colnames(lik.info)[ncol(lik.info)] <- paste(colnames(dataset)[col.lik],juge[j],sep="_")
        }
        rownames(lik.info) <- lik.info[,1]
        lik.info <- lik.info[,-1]
        lik.info <- t(scale(lik.info,center=T,scale=F))
        rownames(lik.info) <- juge
        data1 <- id.avg
        data2 <- rbind(scale(id.avg,center=T,scale=F),scale(int.avg,scale=F))
        data3 <- merge(id.avg,lik.info,all=T,by=0,sort=F)
        rownames(data3) <- data3[,1]
        data3 <- data3[,-1]
        res.pca1 <- PCA(data1,scale.unit=scale.unit,ncp=ncp,graph=F)
        res.pca2 <- PCA(data2,ind.sup=(nrow(data1)+1):nrow(data2),scale.unit=scale.unit,ncp=ncp,graph=F)
        res.pca3 <- PCA(data3,quanti.sup=(ncol(data1)+1):ncol(data3),scale.unit=scale.unit,ncp=ncp,graph=F)
        dev.new()
        layout(matrix(1:2,1,2))
        plot.PCA(res.pca1,choix="ind",cex=0.8,axes=axes,new.plot=F)
        plot.PCA(res.pca1,choix="var",cex=0.8,axes=axes,new.plot=F)
        dev.new()
        layout(matrix(1:2,1,2))
        plot.PCA(res.pca2,choix="ind",cex=0.8,label="ind.sup",axes=axes,new.plot=F)
        plot.PCA(res.pca3,choix="var",cex=0.8,label="quanti.sup",axes=axes,new.plot=F)
        correl <- cor(res.pca2$ind.sup$coord,res.pca3$quanti.sup$coord)
        rownames(correl) <- paste(rownames(correl),"_ideal.senso",sep="")
        colnames(correl) <- paste(colnames(correl),"_ideal.hedo",sep="")
        res$panel$dataset$ideal <- round(scale(id.avg,center=T,scale=F),2)
        res$panel$dataset$perceived <- round(scale(int.avg,center=T,scale=F),2)
        res$panel$dataset$hedonic <- round(lik.info,2)
        res$panel$PCA.ideal <- res.pca1
        res$panel$PCA.ideal_hedo <- res.pca3
        res$panel$PCA.ideal_senso <- res.pca2
        res$panel$correlation <- correl
    }
    if (consist %in% c("consumer","both")){
        int.avg <- int.avg.save
        id.avg <- id.avg.save
        perclik.cor.res <- matrix(NA,nbjuge,nbatt)
        juge.cor.res <- matrix(NA,nbjuge,2)
        rownames(perclik.cor.res) <- rownames(juge.cor.res) <- juge
        colnames(perclik.cor.res) <- attribut.int
        colnames(juge.cor.res) <- c(juge.name,"p-values")
        colnames(id.avg) <- attribut.int
        if (correct)
            id.avg <- id.avg-int.avg.j
        for (j in 1:nbjuge){
            lik.data.j <- lik.data[lik.data[,1]==juge[j],3]
            if (sd(lik.data.j)==0){
                juge.cor.res[j,1] <- juge.cor.res[j,2] <- NA
            } else {
                for (a in 1:nbatt){
                    int.data.j <- int.data[int.data[,1]==juge[j],(a+2)]
                    perclik.cor.res[j,a] <- cor(lik.data.j,int.data.j)
                    if (replace.na)
                        if (is.na(perclik.cor.res[j,a]))
                            perclik.cor.res[j,a]=0
                }
                res.cor <- cor.test(as.matrix(perclik.cor.res[j,]),t(id.avg[j,]),alternative="greater")
                juge.cor.res[j,1] <- res.cor$estimate
                juge.cor.res[j,2] <- res.cor$p.value
            }
        }
        oo <- order(juge.cor.res[,1],decreasing=T)
        juge.cor.res <- juge.cor.res[oo,]
        if (graph){
            dev.new()
            plot(density(juge.cor.res[,1]),main=paste("Relationship between Ideal, Intensity and Liking data","\n","Distribution of cor(ideal,cor(intensity,liking)) for the different ",juge.name,sep=""),xlab="Individual correlation coefficient r(z,r(y,h))")
        }
        res$conso$driver.lik <- magicsort(round(perclik.cor.res,3))
        res$conso$correlations <- round(juge.cor.res,3)
    }
    return(res)
}