\name{plot.IdMap}

\alias{plot.IdMap}

\title{Plot for the Ideal Mapping}

\description{
Option to replot by zooming on the ideal map.
}

\usage{
plot.IdMap(dataset, x1, x2, y1, y2, levels.contour=NULL, color=FALSE, inverse=FALSE)
}

\arguments{
  \item{dataset}{An object resulting from the \emph{IdMap} function}
  \item{x1}{The lower limit of interest on the X axisable }
  \item{x2}{The upper limit of interest on the X axis}
  \item{y1}{The lower limit of interest on the Y axis}
  \item{y2}{The upper limit of interest on the Y axis}
  \item{levels.contour}{The levels (between 0 and 1) to consider for the colors on the surface plot.
  By default, they are set automatically based on the results }
  \item{color}{Boolean, define whether the map is in color or in black and white}
  \item{inverse}{Boolean}
}

\details{
Replot the Ideal Map by zooming on the area of interest
}

\value{
Return the IdMap zoomed on the area of interest.
}



\author{Worch Thierry (thierry@qistatistics.co.uk)}

\seealso{ \code{\link{IdMap}}}

\examples{
\dontrun{
data(perfume_ideal)
res <- IdMap(perfume_ideal, col.p=2, col.j=1, col.lik=ncol(perfume_ideal), id.recogn="id_")
plot.IdMap(res, x1=-7, x2=10, y1=-5, y2=7, levels.contour=NULL, color=TRUE)
}
}

\keyword{Ideal Mapping}
